"use strict";
var DecoratorUtil = (function () {
    function DecoratorUtil() {
    }
    /**
     * create param decorators
     * @param value the value for the decorator
     * @param key the key under wich the value is saved
     * @returns the decorated function
     */
    DecoratorUtil.createParamDecorator = function (value, key) {
        return function (target, propertyKey, parameterIndex) {
            var existingDecorators = Reflect.getOwnMetadata(key, target, propertyKey) || [];
            existingDecorators.push({ paramName: value, index: parameterIndex });
            Reflect.defineMetadata(key, existingDecorators, target, propertyKey);
        };
    };
    return DecoratorUtil;
}());
exports.DecoratorUtil = DecoratorUtil;
//# sourceMappingURL=decoratorUtil.js.map